@echo off
::	POET start_ugmanager.bat fuer NX5(6)+TcEng2007
::	basiert auf C:\tce2007\portal\start_ugmanager.bat aus Installation 2008-02 / siehe history
::	Masterfile: \\cad98\C$\tce2007\portal\start_ugmanager.bat
::	1.xx		2009-01-27	ugnx@zwatz.net	ist eigener Tree !!
::	2.00		2008-11-04		zwattho	Support fuer NX6, Abfrage wenn POET_NX_ASK_NX_VERSION=="YES" , POET_PREFERRED_NX_VERSION [ NX5 , NX6 ]
::								Auch MR / MPs sind so abbildbar - bei Verwendung von mehreren Minor Releases desselben Major Releases muss auch ein 
::								zugehoeriger RegistryKey zur ugraf.exe( " V2x.x" ... ) angelegt werden  ( HKEY_LOCAL_MACHINE / SOFTWARE / Unigraphics Solutions / Installed Applications )!
::	2.01		2008-12-09	zwattho	Automatisches Setzen von UGII_SMP_ENABLE bei MultiCore/MultiCPU
::	2.10		2009-01-28	ugnx@zwatz.net	Fuer mehrere NX Versionen und Test DB
::								POET_NX_CUSTOM_DIR kommt aus portal.bat ! POET_NX_CUSTOM_GROUP ermitteln
::								POET_NX_ASK_NX_VERSION retired, user_opt_system_parameters.def legt fest ob Sprachen/Versionen gewaehlt werden duerfen.
::	2.11		2009-02-01	ugnx@zwatz.net	NX Versionen 505 506 und 6 integriert
::	2.12		2009-09-30	zwattho		Testing erweitert: NX 5.0.6.3 MP4

:: File Name:  START_UGMANAGER.BAT
:: ************************************************************************
:: This script will set the appropriate variables and then run UG/Manager
:: without workspace.
::
:: Copyright (c) 1995-1999
:: Unigraphics Solutions, Cypress, CA 90630
:: All Rights Reserved
::
:: Input Parameters:
::
:: Command line parameters will be passed through to Unigraphics.
::
:: NOTE: You MUST use a colon "" for key=value pairs
:: 
::       For example:
::       start_ugmanager test.bkm -opts "-u=tom" "-p=tom"
::
:: ************************************************************************
:: Revision History:
::
:: REV   AUTHOR      DATE      COMMENT
:: ===   ======      =======   =======
:: 31-Jul-2001  rupert                  Add UGII_BASE_DIR
:: 01-Oct-2001  brownch                 Fixed PR4338228.
:: 16-Dec-2005  yang                    4-tier NX Manager
:: 08-Jan-2006  Mathieu Sarrazy         Merge from CVG_P10.0.1.5
:: $HISTORY$
:: ************************************************************************

::	TMP und TEMP sollen fuer alle einheitlich sein ....
set TMP=C:\Temp
set TEMP=C:\Temp

:: Userbezogene Variablen fuer start_ugmanager.bat aus zentralem Konfig File ( das ist nie ein lokales File ...) auswerten
@echo.
@echo Looking for userspecific system settings for user  %USERNAME%
@echo.
for /F "eol=; delims= tokens=1,2,3" %%i in (%POET_NX_CUSTOM_DIR%\v5\site\etc\user_opt_system_parameters.def) do call :set_user_opt_parameters %%i %%j %%k
@echo.
@echo Done.....

:: Check whether POET_NX_CUSTOM_DIR  and POET_TCE_PORTAL_USED is set
if "%POET_NX_USE_LOCAL_CUSTOM_DIR%"=="YES" set POET_NX_CUSTOM_DIR=C:\local\NXcustom.d
if not defined POET_NX_CUSTOM_DIR goto :POET_NX_CUSTOM_DIR_error
if NOT EXIST "%POET_NX_CUSTOM_DIR%" goto :POET_NX_CUSTOM_DIR_error
if not defined POET_TCE_PORTAL_USED goto :POET_TCE_PORTAL_USED_error

:: 4-tier only line set UGII_UGMGR_COMMUNICATION=HTTP
::
:: Figure out the startup directory
:: The order of precedence is: API_DEFAULT_DIR, HOME, IMAN_TMP_DIR, UGII_TMP_DIR, TEMP
:: Otherwise we might end up in trouble if the current working
:: directory we were started up from is not writable.
:: Damit keine tmp files nach HOME kommen,  tauschen HOME und TEMP die Plaetze 	( zwattho 2008-05-30 )
set START_DIR=%API_DEFAULT_DIR%
if "%START_DIR%"=="" set START_DIR=%TEMP%
if "%START_DIR%"=="" set START_DIR=%IMAN_TMP_DIR%
if "%START_DIR%"=="" set START_DIR=%UGII_TMP_DIR%
if "%START_DIR%"=="" set START_DIR=%HOME%

cd /d %START_DIR%
:: Disable the flash
set UGII_DISABLE_FLASH=YES

:: Sprache fuer NX UI abfragen ?
if "%POET_NX_ASK_LANGUAGE%"=="YES" call :ask_NX_language
:: NX Default Version festlegen
set POET_NXTOSTART_DEFAULT_PRODUCT=NX5
set POET_NXTOSTART_DEFAULT_TESTING=NX5
if "%POET_TCE_PORTAL_USED%"=="PRODUCT" set POET_NXTOSTART=%POET_NXTOSTART_DEFAULT_PRODUCT%
if "%POET_TCE_PORTAL_USED%"=="TESTING" set POET_NXTOSTART=%POET_NXTOSTART_DEFAULT_TESTING%
:: Ggf. Versionsabfrage ueberspringen ( Standard ):
if not defined POET_NX_ALLOW_VERSION_TESTING goto :skip_ask_NX_version_use_default

:: NX Version abfragen + valid choice ?
if "%POET_TCE_PORTAL_USED%"=="PRODUCT" goto :check_selected_NX_version_PRODUCT
if "%POET_TCE_PORTAL_USED%"=="TESTING" goto :check_selected_NX_version_TESTING

:check_selected_NX_version_PRODUCT
if not "%POET_NX_ALLOW_VERSION_TESTING%"=="ALL" goto :skip_ask_NX_version_use_default
if "%POET_NX_ALLOW_VERSION_TESTING%"=="ALL" goto :ask_NX_version

:check_selected_NX_version_TESTING
if "%POET_NX_ALLOW_VERSION_TESTING%"=="TESTING_ONLY" goto :ask_NX_version
if "%POET_NX_ALLOW_VERSION_TESTING%"=="ALL" goto :ask_NX_version

:: Default NX Version starten wenn nicht danach gefragt wird ...
:skip_ask_NX_version_use_default
if "%POET_TCE_PORTAL_USED%"=="PRODUCT" goto :set_env_%POET_NXTOSTART_DEFAULT_PRODUCT%
if "%POET_TCE_PORTAL_USED%"=="TESTING" goto :set_env_%POET_NXTOSTART_DEFAULT_TESTING%

:: Start Unigraphics through the launcher program
:startNX

:: Check whether IMAN_ROOT is set
if NOT EXIST "%IMAN_ROOT%" goto :iman_error
:: Check whether UGII_BASE_DIR is set
if NOT EXIST "%UGII_BASE_DIR%" goto :ug_error

@echo.
@echo Using POET_TCE_PORTAL_USED =  %POET_TCE_PORTAL_USED%
@echo Using POET_NX_CUSTOM_DIR =  %POET_NX_CUSTOM_DIR%
@echo Using %POET_NXTOSTART% with %UGII_LANG% UI
@echo.
if "%POET_NX_ALLOW_VERSION_TESTING%"=="TESTING_ONLY" pause
if "%POET_NX_ALLOW_VERSION_TESTING%"=="ALL" pause

:: ACHTUNG: Bei Verwendung mehrerer MinorReleases ( MR / MP ) muessen manuell die Registry Keys angepasst / estellt werden !
if "%POET_NXTOSTART%"=="NX5" %UGII_ROOT_DIR%\ugs_router -ugm -enable_cancel -version=V23.0 %*
if "%POET_NXTOSTART%"=="NX506MP4" %UGII_ROOT_DIR%\ugs_router -ugm -enable_cancel -version=V23.1 %*
if "%POET_NXTOSTART%"=="NX6" %UGII_ROOT_DIR%\ugs_router -ugm -enable_cancel -version=V24.0 %*
goto :ENDOFFILE

:set_env_NX5
set IMAN_ROOT=C:\tce2007
set UGII_BASE_DIR=C:\ugnx5
set UGII_ROOT_DIR=%UGII_BASE_DIR%\ugii
:: Bei MultiCore/MultiCPU Systemen enablen wir SMP
if "%NUMBER_OF_PROCESSORS%"=="2" set UGII_SMP_ENABLE=1
if "%NUMBER_OF_PROCESSORS%"=="4" set UGII_SMP_ENABLE=1
if "%NUMBER_OF_PROCESSORS%"=="6" set UGII_SMP_ENABLE=1
if "%NUMBER_OF_PROCESSORS%"=="8" set UGII_SMP_ENABLE=1
:: Man kann noch gesondert von Admin Seite her Usern bestimmte Umgebungsvariablen setzen, z.B. POET_NX_CUSTOM_GROUP
@echo.
@echo Looking for userspecific NX settings for user  %USERNAME%
@echo.
for /F "eol=; delims= tokens=1,2,3" %%i in (%POET_NX_CUSTOM_DIR%\v5\site\etc\user_opt_parameters.def) do call :set_user_opt_parameters %%i %%j %%k
@echo.
@echo Done.....
:: In NX5 verwenden wir $HOME fuer User customization - wir brauchen ein SubDir fuers Release plus ein temp  :
if NOT EXIST "%HOME%" set HOME=J:\NXcustom.d
if NOT EXIST "%HOME%\v5" mkdir "%HOME%\v5"
if NOT EXIST "%HOME%\v5\tmp" mkdir "%HOME%\v5\tmp"
:: letztendlich springen wir ins SubDir fuers NX Release ...
set HOME=%HOME%\v5
:: We have to append the path to the corba libraries.
:: As long as the IMAN Server is running on the local host
:: this will be IMAN_BIN.
set IMANLIBS=%IMAN_BIN%
if "%IMAN_BIN%"=="" set IMANLIBS=%IMAN_ROOT%\bin
set Path=%PATH%;%IMANLIBS%
:: Set the pdi corba library.
:: This expects this library to be found in UGII_LIB_PATH
set UGII_UGMGR_EXTERNAL_COMMS_LIB=pdi_corba_client
:: set POET_NX_CUSTOM_DIR=T:\NXcustom.d
set UGII_ENV_FILE=%POET_NX_CUSTOM_DIR%\v5\ugii_env.dat
::	Da ANSYS ab V11 SP1 staendig selbsttaetig UGII_CUSTOM_DIRECTORY_FILE verdreht/setzt, wirds als Workaround explizit unter Umgehung
::	von UGII_ENV_FILE gesetzt:
set UGII_CUSTOM_DIRECTORY_FILE=%POET_NX_CUSTOM_DIR%\v5\site\custom_dirs.dat
:: 	Und das NX Install Dir geben wir auch gleich Releasebezogen mit:
set DSUGII_ROOT_DIR=%UGII_ROOT_DIR%
:: UGII_TEMPLATE_DIR kommt aus start_ugmanager.bat um eventuelle Konflikte mit NX local von vorneherein auszuschliessen (Empfehlung EETAC)
set UGII_TEMPLATE_DIR=%POET_NX_CUSTOM_DIR%\v5\site\templates
:: In NX5 kann man immer noch nicht sauber  Paletten definieren daher richtets ein Registry Import:
regedit /s %POET_NX_CUSTOM_DIR%\v5\site\etc\register_palette_files.reg
:: Im Testsystem soll das NX Fenster einen anderen Titel haben ....
if "%POET_TCE_PORTAL_USED%"=="TESTING" set UGII_MAIN_MENU_FILE=%POET_NX_CUSTOM_DIR%\v5\site\etc\ug_main_test_system_hint.men
goto :startNX

:set_env_NX506MP4
set IMAN_ROOT=C:\tce2007
set UGII_BASE_DIR=C:\ugnx506MP4
set UGII_ROOT_DIR=%UGII_BASE_DIR%\ugii
:: Bei MultiCore/MultiCPU Systemen enablen wir SMP
if "%NUMBER_OF_PROCESSORS%"=="2" set UGII_SMP_ENABLE=1
if "%NUMBER_OF_PROCESSORS%"=="4" set UGII_SMP_ENABLE=1
if "%NUMBER_OF_PROCESSORS%"=="6" set UGII_SMP_ENABLE=1
if "%NUMBER_OF_PROCESSORS%"=="8" set UGII_SMP_ENABLE=1
:: Man kann noch gesondert von Admin Seite her Usern bestimmte Umgebungsvariablen setzen, z.B. POET_NX_CUSTOM_GROUP
for /F "eol=; delims= tokens=1,2,3" %%i in (%POET_NX_CUSTOM_DIR%\v5\site\etc\user_opt_parameters.def) do call :set_user_opt_parameters %%i %%j %%k
:: In NX5 verwenden wir $HOME fuer User customization - wir brauchen ein SubDir fuers Release plus ein temp  :
if NOT EXIST "%HOME%" set HOME=J:\NXcustom.d
if NOT EXIST "%HOME%\v5" mkdir "%HOME%\v5"
if NOT EXIST "%HOME%\v5\tmp" mkdir "%HOME%\v5\tmp"
:: letztendlich springen wir ins SubDir fuers NX Release ...
set HOME=%HOME%\v5
:: We have to append the path to the corba libraries.
:: As long as the IMAN Server is running on the local host
:: this will be IMAN_BIN.
set IMANLIBS=%IMAN_BIN%
if "%IMAN_BIN%"=="" set IMANLIBS=%IMAN_ROOT%\bin
set Path=%PATH%;%IMANLIBS%
:: Set the pdi corba library.
:: This expects this library to be found in UGII_LIB_PATH
set UGII_UGMGR_EXTERNAL_COMMS_LIB=pdi_corba_client
:: set POET_NX_CUSTOM_DIR=T:\NXcustom.d
set UGII_ENV_FILE=%POET_NX_CUSTOM_DIR%\v5\ugii_env.dat
::	Da ANSYS ab V11 SP1 staendig selbsttaetig UGII_CUSTOM_DIRECTORY_FILE verdreht/setzt, wirds als Workaround explizit unter Umgehung
::	von UGII_ENV_FILE gesetzt:
set UGII_CUSTOM_DIRECTORY_FILE=%POET_NX_CUSTOM_DIR%\v5\site\custom_dirs.dat
:: UGII_TEMPLATE_DIR kommt aus start_ugmanager.bat um eventuelle Konflikte mit NX local von vorneherein auszuschliessen (Empfehlung EETAC)
set UGII_TEMPLATE_DIR=%POET_NX_CUSTOM_DIR%\v5\site\templates
:: In NX5 kann man immer noch nicht sauber  Paletten definieren daher richtets ein Registry Import:
regedit /s %POET_NX_CUSTOM_DIR%\v5\site\etc\register_palette_files.reg
:: Im Testsystem soll das NX Fenster einen anderen Titel haben ....
if "%POET_TCE_PORTAL_USED%"=="TESTING" set UGII_MAIN_MENU_FILE=%POET_NX_CUSTOM_DIR%\v5\site\etc\ug_main_test_system_hint.men
goto :startNX


:set_env_NX6
set IMAN_ROOT=C:\tce2007
set UGII_BASE_DIR=C:\ugnx6
set UGII_ROOT_DIR=%UGII_BASE_DIR%\ugii
:: Bei MultiCore/MultiCPU Systemen enablen wir SMP...
if "%NUMBER_OF_PROCESSORS%"=="2" set UGII_SMP_ENABLE=1
if "%NUMBER_OF_PROCESSORS%"=="4" set UGII_SMP_ENABLE=1
if "%NUMBER_OF_PROCESSORS%"=="6" set UGII_SMP_ENABLE=1
if "%NUMBER_OF_PROCESSORS%"=="8" set UGII_SMP_ENABLE=1
:: Man kann noch gesondert von Admin Seite her Usern bestimmte Umgebungsvariablen setzen, z.B. POET_NX_CUSTOM_GROUP
for /F "eol=; delims= tokens=1,2,3" %%i in (%POET_NX_CUSTOM_DIR%\v6\site\etc\user_opt_parameters.def) do call :set_user_opt_parameters %%i %%j %%k
:: In NX5 verwenden wir $HOME fuer User customization - wir brauchen ein SubDir fuers Release plus ein temp  :
if NOT EXIST "%HOME%" set HOME=J:\NXcustom.d
if NOT EXIST "%HOME%\v6" mkdir "%HOME%\v6"
if NOT EXIST "%HOME%\v6\tmp" mkdir "%HOME%\v6\tmp"
:: letztendlich springen wir ins SubDir fuers NX Release ...
set HOME=%HOME%\v6
:: We have to append the path to the corba libraries.
:: As long as the IMAN Server is running on the local host
:: this will be IMAN_BIN.
set IMANLIBS=%IMAN_BIN%
if "%IMAN_BIN%"=="" set IMANLIBS=%IMAN_ROOT%\bin
set Path=%PATH%;%IMANLIBS%
:: Set the pdi corba library.
:: This expects this library to be found in UGII_LIB_PATH
set UGII_UGMGR_EXTERNAL_COMMS_LIB=pdi_corba_client
:: set POET_NX_CUSTOM_DIR=T:\NXcustom.d
set UGII_ENV_FILE=%POET_NX_CUSTOM_DIR%\v6\ugii_env.dat
::	Da ANSYS ab V11 SP1 staendig selbsttaetig UGII_CUSTOM_DIRECTORY_FILE verdreht/setzt, wirds als Workaround explizit unter Umgehung
::	von UGII_ENV_FILE gesetzt:
set UGII_CUSTOM_DIRECTORY_FILE=%POET_NX_CUSTOM_DIR%\v6\site\custom_dirs.dat
:: 	Und das NX Install Dir geben wir auch gleich Releasebezogen mit:
set DSUGII_ROOT_DIR=%UGII_ROOT_DIR%
:: UGII_TEMPLATE_DIR kommt aus start_ugmanager.bat um eventuelle Konflikte mit NX local von vorneherein auszuschliessen (Empfehlung EETAC)
set UGII_TEMPLATE_DIR=%POET_NX_CUSTOM_DIR%\v6\site\templates
:: Zum Verbinden mit TCE 2007 MP6 braucht man noch folgende Einstellungen:
set UGII_UGMGR_SOA_ENABLED=true
set UGII_UGMGR_USE_SOA=true

:: In NX5 kann man immer noch nicht sauber  Paletten definieren daher richtets ein Registry Import:
:: regedit /s %POET_NX_CUSTOM_DIR%\v5\site\etc\register_palette_files.reg
goto :startNX

:ask_NX_language
@echo +++++++++++++++++++++++++++++++++++++++++++++
@echo In welcher Sprache soll NX gestartet werden ?
@echo d ..... deutsch
@echo e ..... english
@echo +++++++++++++++++++++++++++++++++++++++++++++
@set /p SPRACHE=Eingabe ( "d" oder "e" )

if "%SPRACHE%"=="d" goto :lang_de
if "%SPRACHE%"=="e" goto :lang_en
if "%SPRACHE%"=="" goto :lang_en

@goto :lang_invalid

:lang_de
@set UGII_LANG=german
@echo ------------------------------
@echo UGII_LANG auf "%UGII_LANG%" gesetzt
@echo ------------------------------
@goto :eof

:lang_en
@set UGII_LANG=english
@echo -------------------------------
@echo UGII_LANG auf "%UGII_LANG%" gesetzt
@echo -------------------------------
@goto :eof

:lang_invalid
@echo -------------------
@echo Falsche Sprache eingegeben !
@echo -------------------
@goto :ask_NX_language

:ask_NX_version
@echo +++++++++++++++++++++++++++++++++++++++++++++
@echo Welche NX Version soll gestartet werden ?
@echo NX5      ..... NX 5.0.6.3 MP3
@echo NX506MP4 ..... NX 5.0.6.3 MP4
@echo NX6      ..... NX 6
@echo.
@echo +++++++++++++++++++++++++++++++++++++++++++++
@echo.
@set /p POET_NXTOSTART=Eingabe ( "NX5" , "NX506MP4" oder "NX6" )

if "%POET_NXTOSTART%"=="NX5" goto :set_env_%POET_NXTOSTART%
if "%POET_NXTOSTART%"=="NX506MP4" goto :set_env_%POET_NXTOSTART%
if "%POET_NXTOSTART%"=="NX6" goto :set_env_%POET_NXTOSTART%
if "%POET_NXTOSTART%"=="" goto :skip_ask_NX_version_use_default
@goto :invalid_NX_version_entered

:invalid_NX_version_entered
@echo.
@echo Invalid Version  %POET_NXTOSTART%  entered .... starting default NX release ...
@echo.
@goto :skip_ask_NX_version_use_default

:set_user_opt_parameters
if /I "%1"=="%USERNAME%" set %2=%3
if /I "%1"=="%USERNAME%" @echo Setting %2 = %3
goto :eof

:ug_error
echo UGII_BASE_DIR must be set or does not exist
pause
goto :ENDOFFILE

:iman_error
echo IMAN_ROOT must be set
pause
goto :ENDOFFILE

:POET_NX_CUSTOM_DIR_error
echo POET_NX_CUSTOM_DIR must be set
pause
goto :ENDOFFILE

:POET_TCE_PORTAL_USED_error
echo POET_TCE_PORTAL_USED must be set
pause
goto :ENDOFFILE

:ENDOFFILE

@echo on

